"dump.lsd.library" <-
function(){
dump(c("dump.lsd.library","depth.cont.for.mu","max.depth.for.mu","distribution.max.depth","distribution.depth.contours","distribution.max.depth.line","MAD.for.distr","distribution.MAD.line","sample.depth.cont.for.mu","sample.max.depth.for.mu","sample.max.depth","sample.depth.contours","sample.max.depth.line","sample.MAD.line","plot.depth.contours","add.max.depth.MAD.lines"),"lsd_library.asc")}
"depth.cont.for.mu" <-
function(d,mu,qdist=function(x){qnorm(x,0,1)}, pdist=function(x){pnorm(x,0,1)},length=100){
# Calculates the depth contours with respect to sigma for a given mu
# for the distribution dist for depth d
# qdist denotes the quantiles and pdist the distribution function of this distribution
# The result is a list, where lbound denoted the lower bound, ubound the upperbound and 
# tbound is a logic variable which is true if lbound<=ubound 
b<- pdist(mu)
#cat("b: ", b, "\n")
if(b+d<1-0.0000001 & b-d>0.0000001){
  beta<-seq(b-d,b,length=length)
  lbeta<-(mu-qdist(beta))*(qdist(d+beta)-mu)
#  cat(lbeta, "\n")
  lbound<-max(sqrt(abs(lbeta)))
# cat("beta: ", beta,"\n")
# cat("lbound: ",lbound, "\n")
#  plot(beta[2:(length-1)],lbeta[2:(length-1)],type="l",ylim=c(0,1.7),xlim=c(0,1))
  beta<-seq(0,d,length=length)
  ubeta<-(mu-qdist(beta))*(qdist(1-d+beta)-mu)
#  cat("ubeta: ", ubeta, "\n") 
  ubound<-min(sqrt(abs(ubeta)))
#  cat("ubound: ", ubound, "\n")
#  lines(beta[2:(length-1)],ubeta[2:(length-1)])
# cat("b: ", b, " lbound: ", lbound, " ubound: ", ubound, "\n") 
  if(lbound <= ubound){tbound<-T}
  else{tbound<-F}
}
else{
   lbound<-1
   ubound<-0
   tbound<-F
   }
   bound<-c(lbound,ubound,tbound)
   names(bound)<-c("lbound","ubound","tbound")
   bound 
}
"max.depth.for.mu" <-
function(mu,qdist=function(x){qnorm(x,0,1)}, pdist=function(x){pnorm(x,0,1)},d.min=1/3,lengthbeta=100,iter=10,eps=0.0001){
# Calculates the maximum location-scale depth for a given mu 
# for the distribution dist 
# qdist denotes the quantiles and pdist the distribution function of this distribution
# Uses function depth.cont.for.mu
d<-min(c(pdist(mu),1-pdist(mu)))
#cat("d: ", d)
#d<-0.5
cont<-depth.cont.for.mu(d,mu,qdist=qdist,pdist=pdist,length=lengthbeta)
#cat(cont, "  ubound: ", cont["ubound"], "lbound: ", cont["lbound"],"\n")
difbound<-cont["ubound"]-cont["lbound"]
#cat("difbound: ", difbound, "\n")
if(abs(difbound)>eps){
    i<-1
    d.up<-d
    d.low<-d.min
#    while(i<iter & (abs(difbound)>eps & d.up-d.low>eps)){
    while(i<iter & (abs(difbound)>eps )){
      i<-i+1
      if(difbound < -eps){
       d.up<-d
       d<-(d.up+d.low)/2 
#      cat("difbound < - eps, difbound: ", difbound, "i: ", i, "d.up: ",
#            d.up, "d.low: ", d.low,"\n")
#      cat("d: ", d, "\n")
       cont<-depth.cont.for.mu(d,mu,qdist=qdist,pdist=pdist,length=lengthbeta)
       difbound<-cont["ubound"]-cont["lbound"]
       tbound<-cont["tbound"]
       }
       else{
       d.low<-d
       d<-(d.up+d.low)/2
#      cat("difbound > eps, difbound: ", difbound, "i: ", i, "d.up: ", d.up, "d.low: ",                                #          d.low,"\n")
#      cat("d: ", d, "\n")
       cont<-depth.cont.for.mu(d,mu,qdist=qdist,pdist=pdist,length=lengthbeta)
       difbound<-cont["ubound"]-cont["lbound"]
       tbound<-cont["tbound"]
       }
    }
}
res<-c(d,(cont["ubound"]+cont["lbound"])/2,i,difbound,tbound)
names(res)<-c("d","sigma","i","difbound","tbound")
#list(d=d,sigma=cont["ubound"],i=i,difbound=difbound) 
res 
}
"distribution.max.depth" <-
function(qdist=function(x){qnorm(x,0,1)}, pdist=function(x){pnorm(x,0,1)},d.min=1/3,lengthbeta=100,iter=10,eps=0.001){
# Calculates the maximum location-scale depth  
# for the distribution dist 
# qdist denotes the quantiles and pdist the distribution function of this distribution
# Uses function depth.cont.for.mu and max.depth.for.mu
mu.mid<-qdist(0.5)
mu.res<-max.depth.for.mu(mu.mid,qdist=qdist,      pdist=pdist,d.min=d.min,lengthbeta=lengthbeta,iter=iter,eps=eps)
d<-mu.res["d"]
s<-mu.res["sigma"]
difb<-mu.res["difbound"]
i.mu<-mu.res["i"]
#cat("d: ", d, "s: ", s, "difb: ", difb, "\n")
if(d<0.5){
  i<-1
  mu.up<-qdist(2/3)
  mu.low<-qdist(1/3)
  while(i<iter & mu.up-mu.low>eps){
     i<-i+1
     mu.mid.low<-(mu.mid+mu.low)/2
     mu.mid.up<-(mu.mid+mu.up)/2
     cont.low<-depth.cont.for.mu(d,mu.mid.low,qdist=qdist,pdist=pdist,length=lengthbeta)
     cont.up<-depth.cont.for.mu(d,mu.mid.up,qdist=qdist,pdist=pdist,length=lengthbeta)
     if(cont.low["ubound"]-cont.low["lbound"]>eps){
        mu.res<-max.depth.for.mu(mu.mid.low,qdist=qdist, pdist=pdist,
               d.min=d.min,lengthbeta=lengthbeta,iter=iter,eps=eps)
        d<-mu.res["d"]
        s<-mu.res["sigma"]
        difb<-mu.res["difbound"]
        i.mu<-cbind(i.mu,mu.res["i"])
        mu.up<-mu.mid
        mu.mid<-mu.mid.low
#        cat("1.Fall (low), i: ",i, "depth: ", d, "mu.mid: ", mu.mid, "s: ", s, "\n")
#        cat("    mu.up: ", mu.up, "mu.low: ", mu.low, "i.mu: ", mu.res["i"], "difb: ", difb, "\n")
      }
      else{
        if(cont.up["ubound"]-cont.up["lbound"]>eps){
           mu.res<-max.depth.for.mu(mu.mid.up,qdist=qdist, pdist=pdist,
               d.min=d.min,lengthbeta=lengthbeta,iter=iter,eps=eps)
           d<-mu.res["d"]
           s<-mu.res["sigma"]
           difb<-mu.res["difbound"]
           i.mu<-cbind(i.mu,mu.res["i"])
           mu.low<-mu.mid
           mu.mid<-mu.mid.up
#           cat("2. Fall (up), i: ",i, "depth: ", d, "mu.mid: ", mu.mid, "s: ", s, "\n")
#           cat("    mu.up: ", mu.up, "mu.low: ", mu.low,"i.mu: ", mu.res["i"], "difb: ", difb,                         "\n")
          }
         else{
           mu.low<-mu.mid.low
           mu.up<-mu.mid.up
          i.mu<-cbind(i.mu,1)
#           cat("3. Fall, i: ",i, "depth: ", d, "mu.mid: ", mu.mid, "s: ", s, "\n")
#           cat("    mu.up: ", mu.up, "mu.low: ", mu.low, "\n")
         }
     }
     }
}
#cat(i.mu,"\n")
cat("Sum of all iterations: ", sum(i.mu), "Maximum number of iterations in substeps: ", max(i.mu)," Number of substeps: ", length(i.mu), "\n")
res<-c(d,mu.mid,s)
names(res)<-c("max.depth","mu","sigma")
res
#list(max.depth=d,mu=mu.mid, sigma=s, iter.sum=sum(i.mu))
}
"distribution.depth.contours" <-
function(depth=c(0.1,0.2,0.3,0.4),qdist=function(x){qnorm(x,0,1)}, pdist=function(x){pnorm(x,0,1)},lengthmu=100,lengthbeta=100){
# Calculates the population depth contours 
# for the distribution dist for depth depth
# qdist denotes the quantiles and pdist the distribution function of this distribution
#
cont.all<-vector("list",length=length(depth))
for(j in 1:length(depth)){
  d<-depth[j]
  mu<-seq(qdist(d),qdist(1-d),length=(lengthmu+2))[2:(lengthmu+1)]
# provides mu from qdist(d) up to qdist(1-d) but without the end points
  cont<-depth.cont.for.mu(d,mu[1],qdist=qdist,pdist=pdist,length=lengthbeta)
  for(i in 2:(length(mu))){
     cont<-rbind(cont,depth.cont.for.mu(d,mu[i],qdist=qdist,pdist=pdist,length=lengthbeta))
    }
  if(sum(cont[,"tbound"])>1){
     cont.exist<-T
     tbound<-as.logical(cont[,"tbound"])
     cont<-cont[tbound,]
     lbound<-cont[,"lbound"]
     ubound<-cont[,"ubound"]
     mubound<-mu[tbound]
     cont.all[[j]]<-list(depth=d,cont.exist=cont.exist,mubound=mubound,
            lbound=lbound,ubound=ubound)
  }
  else{
    cont.exist<-F
    cont.all[[j]]<-list(depth=d,cont.exist=cont.exist)
    cat(" No contour for the depth ", d, "\n")
  }
}
cont.all
}
"distribution.max.depth.line" <-
function(qdist=function(x){qnorm(x,0,1)}, pdist=function(x){pnorm(x,0,1)},mu.min,mu.max,lengthmu=50,d.min=0.05,lengthbeta=100,iter=50,eps=0.0001){
# Calculates the scale with maximum location-scale depth for every mu in [mu.min,mu.max]
# for the distribution dist 
# qdist denotes the quantiles and pdist the distribution function of this distribution
# Uses function max.depth.for.mu
mu<-seq(mu.min,mu.max,length=lengthmu)
d.mu<-rep(0,lengthmu)
s.mu<-rep(0,lengthmu)
i.mu<-rep(0,lengthmu)
difb.mu<-rep(0,lengthmu)
p.mu<-rep(T,lengthmu)
for(i in 1:(lengthmu)){
   d.res<-max.depth.for.mu(mu[i],qdist=qdist,pdist=pdist,d.min=d.min,lengthbeta=lengthbeta,
iter=iter,eps=eps)
   s.mu[i]<-d.res["sigma"]
#   d.mu[i]<-d.res["d"]
   difb.mu[i]<-d.res["difbound"]
   i.mu[i]<-d.res["i"]
# Checking whether the precision is o.k.:
   if(abs(difb.mu[i])>eps){
       p.mu[i]<-F
   }
   else{
       p.mu[i]<-T
   }
   }
# Taking only the components with correct precision
if(sum(p.mu)<lengthmu){
   precp<-lengthmu-sum(p.mu)
   mu<-mu[p.mu]
   s.mu<-s.mu[p.mu]
   difb.mu<-difb.mu[p.mu]
   i.mu<-i.mu[p.mu]
}
else{
   precp<-0
}
max.i<-max(i.mu)
max.difb<-max(difb.mu)
min.difb<-min(difb.mu)
cat("Number of precision problems: ", precp, "max.i: ", max.i, "max.difb: ", max.difb, "min.difb: ", min.difb, "\n")
#list(mu=mu,s.mu=s.mu, difb.mu=difb.mu)
list(mu=mu,s.mu=s.mu)
}
"distribution.MAD" <-
function(qdist=function(x){qnorm(x)}, pdist=function(x){pnorm(x)},mu=qdist(0.5),sym=F, iter=100,eps=0.00000001){
# Calculates the MAD from mu for a distribution dist
# pdist is the distribution function and qdist the quantile of the distribution
# If sym=T, then it is a symmetric distribution and mu is assumed to be the median
# iter is number of iterations
# eps is precision
if(sym){
  mad<-qdist(0.75)-qdist(0.5)
  }
else{
  p<-pdist(mu)
  if(p+0.25<1-eps & p-0.25 > eps){
    d<- max(c(qdist(p+0.25)-mu,mu-qdist(p-0.25)))
#    cat("p: ", p, "d: ", d)
  }
  else{
     if(p+0.25>=1-eps){
        d<- mu-qdist(p-0.5)
#        cat("p: ", p, "d: ", d)
     }
     else{
        d<- qdist(p+0.5)-mu
 #       cat("p: ", p, "d: ", d)
    }
  }
  d.up<- d
  d.low<-0
  i<-1
  dif<-pdist(mu+d)-pdist(mu-d)-0.5
 # cat(" dif: ", dif, "d.low: ", d.low, "d.up: ", d.up, "\n")
  while(i < iter & abs(dif) > eps){
    i<-i+1
    if(dif > eps){
       d.up<-d
       d<- (d.up+d.low)/2
       dif<-pdist(mu+d)-pdist(mu-d)-0.5
#       cat(i, " Case low: d.low: ", d.low, "d: ", d, "d.up: ", d.up, "dif: ", dif, "\n")
    }
    else{
       d.low<-d
       d<- (d.up+d.low)/2
       dif<-pdist(mu+d)-pdist(mu-d)-0.5
#       cat(i, " Case up: d.low: ", d.low, "d: ", d, "d.up: ", d.up, "dif: ", dif, "\n")
    }
  }
mad<-d
}
mad
}
"distribution.MAD.line" <-
function(qdist=function(x){qnorm(x)},pdist=function(x){pnorm(x)},mu.min,mu.max,
lengthmu=100,sym=F, iter=100,eps=0.00000001){
# Calculates the MAD from mu for a distribution dist,
# where mu varies between mu.min and mu.max.
# pdist is the distribution function and qdist the quantile of the distribution
# If sym=T, then it is a symmetric distribution and mu is assumed to be the median
# iter is number of iterations
# eps is precision
# Uses distribution.MAD
mu<-seq(mu.min,mu.max,length=lengthmu)
MAD<- rep(0,lengthmu)
for(i in 1:lengthmu){
   MAD[i]<-distribution.MAD(qdist=qdist,pdist=pdist,mu=mu[i], sym=sym, iter=iter,
         eps=eps)
#   cat("mu[i]: ", mu[i], "MAD: ", MAD[i],"\n")
}
list(mu=mu,MAD=MAD)
}
"sample.depth.cont.for.mu" <-
function(d,mu,y,length=100){
# Calculates the depth contours with respect to sigma for a given mu
# for the the data set y for depth d
# The result is a vector, where lbound denoted the lower bound, ubound the upperbound and 
# tbound is a logic variable which is true if lbound<=ubound 
y<-sort(y)
M<-0
N<-length(y)
for(i in 1:N){
   if(y[i]<mu){
       M<-M+1
   }
   i<-i+1
}
if(y[M+1]>mu){       
  if((d<=M & d<=N-M) & d>0){
     k<-seq(M-d+1,M,1)
     lk<-(mu-y[k])*(y[d+k]-mu)
#    cat(lk, "\n")
     lbound<-max(sqrt(abs(lk)))
#    cat("lbound: ",lbound, "\n")
     k<-seq(1,d,1)
     uk<-(mu-y[k])*(y[N-d+k]-mu)
#    cat("uk: ", uk, "\n") 
     ubound<-min(sqrt(abs(uk)))
#    cat("ubound: ", ubound, "\n")
#    cat("b: ", b, " lbound: ", lbound, " ubound: ", ubound, "\n") 
     case<-0
     if(lbound <= ubound){tbound<-T}
     else{tbound<-F}
  }
  else{
    lbound<-1
    ubound<-0
    case<-0
    tbound<-F
  }
}
if(y[M+1]==mu){       
  if((d<=M & d<=N-M-1) & d>0){
     k<-seq(M-d+1,M,1)
     lk<-(mu-y[k])*(y[d+k]-mu)
#    cat(lk, "\n")
     lbound<-max(sqrt(abs(lk)))
#    cat("lbound: ",lbound, "\n")
     k<-seq(1,d,1)
     uk<-(mu-y[k])*(y[N-d+k]-mu)
#    cat("uk: ", uk, "\n") 
     ubound<-min(sqrt(abs(uk)))
#    cat("ubound: ", ubound, "\n")
#    cat("b: ", b, " lbound: ", lbound, " ubound: ", ubound, "\n") 
     case<-1
     if(lbound <= ubound){tbound<-T}
     else{tbound<-F}
  }
  else{
    lbound<-1
    ubound<-0
    case<-1
    tbound<-F
  }
}
bound<-c(lbound,ubound,tbound, case,M)
names(bound)<-c("lbound","ubound","tbound","case","M")
bound 
}
"sample.max.depth.for.mu" <-
function(mu,y,d.min=0,iter=100,eps=0.0000001){
# Calculates the maximum sample location-scale depth for a given mu 
# for the data set y 
# Uses function sample.depth.cont.for.mu
y<-sort(y)
M<-0
N<-length(y)
for(i in 1:N){
   if(y[i]<mu){
       M<-M+1
   }
   i<-i+1
}
if(y[M+1]>mu){ 
  d<-min(M,N-M)
  }
else{
  d<-min(M,N-M-1)
  }  
cont<-sample.depth.cont.for.mu(d,mu,y=y)
#cat(cont, "  ubound: ", cont["ubound"], "lbound: ", cont["lbound"],"\n")
difbound<-cont["ubound"]-cont["lbound"]
#cat("difbound: ", difbound, "\n")
if(abs(difbound)>eps){
    i<-1
    d.up<-d
    d.low<-d.min
    while(i<iter & (abs(difbound)>eps & d.up-d.low>1)){
      i<-i+1
      if(difbound < -eps){
       d.up<-d
       d<-round((d.up+d.low)/2) 
#       cat("difbound < - eps, difbound: ", difbound, "i: ", i, "d.up: ",
 #           d.up, "d.low: ", d.low,"\n")
 #     cat("d: ", d, "\n")
       cont<-sample.depth.cont.for.mu(d,mu,y=y)
       difbound<-cont["ubound"]-cont["lbound"]
       }
       else{
       d.low<-d
       d<-round((d.up+d.low)/2)
 #      cat("difbound > eps, difbound: ", difbound, "i: ", i, "d.up: ", d.up, "d.low: ",   #           d.low,"\n")
#       cat("d: ", d, "\n")
       cont<-sample.depth.cont.for.mu(d,mu,y=y)
       difbound<-cont["ubound"]-cont["lbound"]
       }
    }
}
if(difbound< -eps){
#   cat("Attention: difbound < -eps, d is reduced by one, d: ", d, "difbound: ",
#         difbound, "\n")
   d<-d-1
   cont<-sample.depth.cont.for.mu(d,mu,y=y)
   difbound<-cont["ubound"]-cont["lbound"]
   }
res<-c(d,(cont["ubound"]+cont["lbound"])/2,i,difbound)
names(res)<-c("d","sigma","i","difbound")
#list(d=d,sigma=cont["ubound"],i=i,difbound=difbound) 
res 
}
"sample.max.depth" <-
function(y,iter=100,eps=0.0001,p.length=10){
# Calculates the maximum sample location-scale depth  
# for the data set y 
# Uses function sample.depth.cont.for.mu and sample.max.depth.for.mu
# p.length is the maximum length of the precision step at the end
y<-sort(y)
N<-length(y)
d.min<-floor(N/3)
n.mid<-round(N/2)
res<-sample.max.depth.for.mu(mu=y[n.mid],y=y,d.min=d.min,iter=iter,eps=eps)
d<-res["d"]
s<-res["sigma"]
difb<-res["difbound"]
i.mu<-res["i"]
#cat("d: ", d, "s: ", s, "difb: ", difb, "\n")
if(d<N/2){
  i<-1
  n.up<-ceiling(N*2/3)
  n.low<-floor(N/3)
#  cat("i: ",i, "depth: ", d, "n.mid: ", n.mid, "s: ", s, "\n")
#  cat( "    n.up: ", n.up, "n.low: ", n.low, "i.mu: ", res["i"], "difb: ", difb, "\n")
dec<-1
  while(i<iter & (n.up-n.low>1 & dec>0)){
     i<-i+1
     n.mid.low<-ceiling((n.mid+n.low)/2)
     n.mid.up<-floor((n.mid+n.up)/2)
 #    cat("i: ", i, " n.low:", n.low, " n.mid.low", n.mid.low, " n.mid:", n.mid,
 #           " n.mid.up:" , n.mid.up, " n.up:", n.up, "\n")
     res.low<-sample.max.depth.for.mu(mu=y[n.mid.low],y=y,d.min=d.min,
               iter=iter,eps=eps)
     res.up<-sample.max.depth.for.mu(mu=y[n.mid.up],y=y,d.min=d.min,
               iter=iter,eps=eps)
     i.mu<-cbind(i.mu,res.low["i"])
     i.mu<-cbind(i.mu,res.up["i"])
     d.low<-res.low["d"]
     d.up<-res.up["d"]
     if(d.low> d ){
        d<-d.low
        s<-res.low["sigma"]
        difb<-res.low["difbound"]
        n.up<-n.mid
        n.mid<-n.mid.low
 #       cat("1.Fall (low): ", "depth: ", d,  "s: ", s,  "n.low: ", n.low,  
 #              "n.mid: ", n.mid," n.up: ", n.up,"\n")
      } # d.low>d
      else{
        if(d.up >d){
           d<-d.up
           s<-res.up["sigma"]
           difb<-res.up["difbound"]
           n.low<-n.mid
           n.mid<-n.mid.up
  #         cat("2. Fall (up) ", "depth: ", d, "s: ", s,  "n.low: ", n.low,  
  #                  "n.mid: ", n.mid," n.up: ", n.up,"\n")
          } # d.up
         else{
           if(d.low< d | d.up < d){
              if(d.low < d){
                 n.low<-n.mid.low
  #               cat("3. Fall (d.low<d): ", "depth: ", d, "s: ", s,  
  #                   "n.low: ", n.low,"n.mid: ", n.mid, " n.up: ", n.up, "\n")
               } # d.low< d 
              if(d.up < d){
                 n.up<-n.mid.up
  #               cat("4. Fall (d.up<d): ", "depth: ", d,"s: ", s, "n.low: ", 
  #                      n.low,  "n.mid: ", n.mid," n.up: ", n.up,  "\n")
               } # d.up < d
           } # d.low< d | d.up < d
           else{
              dec<-0
  #            cat("5. Fall: ", "depth: ", d, "s: ", s,  "n.low: ", n.low, 
  #                            "n.mid: ", n.mid, " n.up: ", n.up,"\n")
           } # d.low< d | d.up < d else
         } # d.up else
     }# d.low else
     } # while
} # d< N/2
# Precision step
length<-max(c(p.length,2*(n.up-n.low+1)))
#cat("Precision step", "length: ", length, "\n")
mu<-seq(y[n.low],y[n.up],length=length)
res<-sample.max.depth.for.mu(mu=mu[1],y=y,d.min=d.min,iter=iter,eps=eps)
i.mu<-cbind(i.mu,res["i"])
for(i in 2:length){
   res<-rbind(res,sample.max.depth.for.mu(mu=mu[i],y=y,d.min=d.min,iter=iter,eps=eps))
#   cat("i: ", i, "res: ", res[i,"i"], "\n")
    i.mu<-cbind(i.mu, res[i,"i"])
   }
d<-max(res[,"d"])
dmax<-rep(1,length)
for(i in 1:length){
     if(res[i,"d"]<d){
         dmax[i]<-0
     }
}
#cat("res[,d]: ", res[,"d"], "\n")
#cat("dmax:      ", dmax, "\n")
dmax<-as.logical(dmax)
#cat("dmax:      ", dmax, "\n")
res<-res[dmax,]
mu<-mu[dmax]
#cat("mu: ", mu, "\n")
if(length(mu)>1){
  length.half<-round(length(mu)/2) 
  mu<-mu[length.half]   
  s<-res[length.half,"sigma"]
  difb<-res[length.half,"difbound"]
}
else{
   s<-res["sigma"]
   difb<-res["difbound"]
}
#cat(i.mu,"\n")
cat("Sum of all iterations: ", sum(i.mu), " Maximum number of iterations in substeps: ", max(i.mu)," Number of substeps: ", length(i.mu), "\n")
res<-c(d,mu,s)
names(res)<-c("max.depth","mu","sigma")
res
}
"sample.depth.contours" <-
function(depth=round(c(0.1,0.2,0.3,0.4)*length(y)),y,lengthmu=1000){
# Calculates the sample depth contours 
# for the data set y for rounded depth values in depth
y<-sort(y)
N<-length(y)
cont.all<-vector("list",length=length(depth))
for(j in 1:length(depth)){
  d<-depth[j]
  if(d>1){
     mu<-seq(y[1+d-1],y[N-d+1],length=(lengthmu+1))
  }
  else{
    mu<-seq(y[1],y[N],length=(lengthmu+1))
  }
  cont<-sample.depth.cont.for.mu(d,mu[1],y)
  for(i in 2:(lengthmu)){
      cont<-rbind(cont,sample.depth.cont.for.mu(d,mu[i],y))
  }
  if(sum(cont[,"tbound"])>1){
     cont.exist<-T
     tbound<-as.logical(cont[,"tbound"])
     cont<-cont[tbound,]
     lbound<-cont[,"lbound"]
     ubound<-cont[,"ubound"]
     mubound<-mu[tbound]
     cont.all[[j]]<-list(depth=d,cont.exist=cont.exist,mubound=mubound,
            lbound=lbound,ubound=ubound)
  }
  else{
     cont.exist<-F
     cat(" No contour for the depth ", d, "\n")
     cont.all[[j]]<-list(depth=d,cont.exist=cont.exist)
  }
}
cont.all
}
"sample.max.depth.line" <-
function(y,mu.min,mu.max,mu.values=T,lengthmu=100,iter=100,eps=0.0000001){
# Caculates the maximum depth and MAD depending on mu
# and the corresponding scales
# for data set y
# If mu.values=T the values for mu.min and mu.max were calculated
# from the data set. Otherwise they can be set.
y<-sort(y)
N<-length(y)
M<-0
for(i in 1:N){
   if(y[i]<=y[1]){
       M<-M+1
   }
   i<-i+1
}
L<-0
for(i in 1:N){
   if(y[N-i+1]>=y[N]){
       L<-L+1
   }
   i<-i+1
}
if(mu.values){
  if(M+1<N-L){
  mu.min<-y[M]+0.01*(y[M+1]-y[M])
  mu.max<-y[N-L+1]-0.01*(y[N-L+1]-y[N-L])
  }
  else{
  mu.min<-1
  mu.max<-0
  }
}
if(mu.min<=y[M]){
  mu.min<-y[M]+0.01*(y[M+1]-y[M])
}
if(mu.max>=y[N-L+1]){
  mu.max<-y[N-L+1]-0.01*(y[N-L+1]-y[N-L])   
}
if(mu.min<mu.max){
  mu<-seq(mu.min,mu.max,length=lengthmu)
  sigma<-mu
  for(i in 1:lengthmu){
    res<-sample.max.depth.for.mu(mu[i],y,d.min=0,iter=iter,eps=eps)
    sigma[i]<-res["sigma"]
  }
}
else{
  cat("no line: mu.max<mu.min", "\n")
}
list(mu=mu,s.mu=sigma)
}
"sample.MAD.line" <-
function(y,mu.min,mu.max,mu.values=T,lengthmu=100){
# Caculates the MAD depending on mu
# for data set y
# If mu.values=T the values for mu.min and mu.max were calculated
# from the data set. Otherwise they can be set.
y<-sort(y)
N<-length(y)
M<-0
for(i in 1:N){
   if(y[i]<=y[1]){
       M<-M+1
   }
   i<-i+1
}
L<-0
for(i in 1:N){
   if(y[N-i+1]>=y[N]){
       L<-L+1
   }
   i<-i+1
}
if(mu.values){
  if(M+1<N-L){
  mu.min<-y[M]+0.01*(y[M+1]-y[M])
  mu.max<-y[N-L+1]-0.01*(y[N-L+1]-y[N-L])
  }
  else{
  mu.min<-1
  mu.max<-0
  }
}
if(mu.min<mu.max){
  mu<-seq(mu.min,mu.max,length=lengthmu)
  madmu<-mu
  for(i in 1:lengthmu){
    madmu[i]<-mad(y,center=mu[i],constant=1)
  }
}
else{
  cat("no line: mu.max<mu.min", "\n")
}
list(mu=mu,MAD=madmu)
}
"plot.depth.contours" <-
function(depth.cont,ratio=1,first.plot=T,mu.min=0,mu.max=0){
# Plots the depth contours 
# given by the contour list depth.cont
# which is the result of distribution.depth.cont 
# or sample.depth.cont
#
l<-length(depth.cont)
for(i in 1:l){
   if(depth.cont[[i]]$cont.exist){
      mubound<-depth.cont[[i]]$mubound
      lbound<-depth.cont[[i]]$lbound
      ubound<-depth.cont[[i]]$ubound
      d<-depth.cont[[i]]$d
      lmu<-length(mubound)
      if(first.plot){
          if(mu.min==mu.max){
              mu.min<-mubound[1]
              mu.max<-mubound[lmu]
          }
          plot(mubound,ubound,type="l", ylim=c(0,(1/ratio)*(mu.max-mu.min)),
             xlim=c(mu.min,mu.max), ylab=expression(sigma),xlab=expression(mu))
          first.plot<-F
      }
      else{
          lines(mubound,ubound)
      }
      lines(mubound,lbound)
      segments(mubound[1],lbound[1],mubound[1],ubound[1])
      segments(mubound[lmu],lbound[lmu],mubound[lmu],ubound[lmu])
   }
   else{
      cat(" No contour for the depth ", d, "\n")
   }
}
}
"add.max.depth.MAD.lines" <-
function(max.depth.line=NULL,MAD.line=NULL){
# Adds the line of scales with maximum location-scale depth for mu 
# given in max.depth.line 
# to an existing contour plot
# if max.depth.line is not equal to 0.
# Adds also the MAD line given in MAD.line
# to an existing contour plot
# if max.depth.line is not equal to 0.
if(is.list(max.depth.line)){
 lines(max.depth.line$mu,max.depth.line$s.mu, lty=2)
}
if(is.list(MAD.line)){
 lines(MAD.line$mu,MAD.line$MAD, lty=3)
}
}
